//+------------------------------------------------------------------+
//|                                            Heiken Ashi Ma T3.mq4 |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//|                                               2009 mod by mladen |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,Forex-TSD.com"
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  DeepSkyBlue
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    MaMetod         = 2;
extern int    MaPeriod        = 6;
extern int    Step            = 1;
extern bool   BetterFormula   = true;
extern int    T3Period        = 14;
extern bool   T3Average       = false;
extern double T3Hot           = 0.70;
extern bool   T3Original      = false;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double UpArrow[];
double DnArrow[];
double trend[];

//
//
//
//
//

double emas[][24];
double alpha;
double c1;
double c2;
double c3;
double c4;

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;



//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, DnArrow); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, UpArrow); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer1); 
   SetIndexBuffer(3, ExtMapBuffer2); 
   SetIndexBuffer(4, ExtMapBuffer3);
   SetIndexBuffer(5, ExtMapBuffer4);
   SetIndexBuffer(6, trend);

   //
   //
   //
   //
   //
   
      double a  = T3Hot;
             c1 = -a*a*a;
             c2 =  3*(a*a+a*a*a);
             c3 = -3*(2*a*a+a+a*a*a);
             c4 = 1+3*a+a*a*a+3*a*a;

      T3Period = MathMax(1,T3Period);
      if (T3Original)
           alpha = 2.0/(1.0 + T3Period);
      else alpha = 2.0/(2.0 + (T3Period-1.0)/2.0);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haClose, haLow, haHigh;
   int    i,limit,counted_bars=IndicatorCounted();
   int    pointModifier;

   //
   //
   //
   //
   //

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { DnArrow[0] = limit+1; return(0); }
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
      if (Digits==3 || Digits==5)
            pointModifier = 10;
      else  pointModifier = 1;               
      for(i=limit; i >= 0; i--)
      {
         if (T3Average)
            {
             maOpen  = iT3(Open[i] ,i, 0);
             maClose = iT3(Close[i],i, 6);
             maLow   = iT3(Low[i]  ,i,12);
             maHigh  = iT3(High[i] ,i,18);
            }
         else
            {
             maOpen  = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_OPEN, i);
             maClose = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_CLOSE,i);
             maLow   = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_LOW,  i);
             maHigh  = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_HIGH, i);
            }
   
         //
         //
         //
         //
         //
        
            if (BetterFormula) {
                  if (maHigh!=maLow)
                        haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
                  else  haClose = (maOpen+maClose)/2; }
            else        haClose = (maOpen+maHigh+maLow+maClose)/4;
                        haOpen   = (ExtMapBuffer3[i+1]+ExtMapBuffer4[i+1])/2;
                        haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                        haLow    = MathMin(maLow,  MathMin(haOpen,haClose));

            if (haOpen<haClose) { ExtMapBuffer1[i]=haLow;  ExtMapBuffer2[i]=haHigh; } 
            else                { ExtMapBuffer1[i]=haHigh; ExtMapBuffer2[i]=haLow;  } 
                                  ExtMapBuffer3[i]=haOpen;
                                  ExtMapBuffer4[i]=haClose;

      
         //
         //
         //
         //
         //

         if (Step>0)
         {
            if( MathAbs(ExtMapBuffer1[i]-ExtMapBuffer1[i+1]) < Step*pointModifier*Point ) ExtMapBuffer1[i]=ExtMapBuffer1[i+1];
            if( MathAbs(ExtMapBuffer2[i]-ExtMapBuffer2[i+1]) < Step*pointModifier*Point ) ExtMapBuffer2[i]=ExtMapBuffer2[i+1];
            if( MathAbs(ExtMapBuffer3[i]-ExtMapBuffer3[i+1]) < Step*pointModifier*Point ) ExtMapBuffer3[i]=ExtMapBuffer3[i+1];
            if( MathAbs(ExtMapBuffer4[i]-ExtMapBuffer4[i+1]) < Step*pointModifier*Point ) ExtMapBuffer4[i]=ExtMapBuffer4[i+1];
         }         

         //
         //
         //
         //
         //
            
            UpArrow[i] = EMPTY_VALUE; 
            DnArrow[i] = EMPTY_VALUE;
            trend[i]   = trend[i+i];
               if (ExtMapBuffer3[i]<ExtMapBuffer4[i]) trend[i] =  1;
               if (ExtMapBuffer3[i]>ExtMapBuffer4[i]) trend[i] = -1;
               if (trend[i]== 1) UpArrow[i] = 1;
               if (trend[i]==-1) DnArrow[i] = 1;
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         DnArrow[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,0,y);
         UpArrow[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,1,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,6,y);
   }
   manageAlerts();
   return(0);         
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iT3(double price, int shift,int buffer)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0+buffer] = price;
         emas[i][1+buffer] = price;
         emas[i][2+buffer] = price;
         emas[i][3+buffer] = price;
         emas[i][4+buffer] = price;
         emas[i][5+buffer] = price;
      }
   else
      {
         emas[i][0+buffer] = emas[i-1][0+buffer]+alpha*(price            -emas[i-1][0+buffer]);
         emas[i][1+buffer] = emas[i-1][1+buffer]+alpha*(emas[i][0+buffer]-emas[i-1][1+buffer]);
         emas[i][2+buffer] = emas[i-1][2+buffer]+alpha*(emas[i][1+buffer]-emas[i-1][2+buffer]);
         emas[i][3+buffer] = emas[i-1][3+buffer]+alpha*(emas[i][2+buffer]-emas[i-1][3+buffer]);
         emas[i][4+buffer] = emas[i-1][4+buffer]+alpha*(emas[i][3+buffer]-emas[i-1][4+buffer]);
         emas[i][5+buffer] = emas[i-1][5+buffer]+alpha*(emas[i][4+buffer]-emas[i-1][5+buffer]);
      }
   return(c1*emas[i][5+buffer] + c2*emas[i][4+buffer] + c3*emas[i][3+buffer] + c4*emas[i][2+buffer]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," HAMA trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"HAMA "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}